Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/HomeController.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/HomeController.cs	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/HomeController.cs	(revision 13739)
@@ -5,4 +5,7 @@
 using Microsoft.AspNet.Mvc;
 using System.ServiceModel.Security;
+using Microsoft.AspNet.Http;
+using System;
+using HeuristicLab.Clients.Hive.WebJobManager.ViewModels;
 
 namespace HeuristicLab.Clients.Hive.WebJobManager.Controllers
@@ -13,9 +16,9 @@
     public class HomeController : Controller
     {
-        private LoginViewModelService loginViewModelService;
+        private WebLoginService weblog;
         private HiveServiceClient client;
-        public HomeController(ILoginViewModelService loginViewModelService)
+        public HomeController()
         {
-            this.loginViewModelService = (LoginViewModelService)loginViewModelService;
+            this.weblog = WebLoginService.Instance;
         }
         #region Login
@@ -27,6 +30,13 @@
         {
             ViewBag.Title = "Login";
-            loginViewModelService.clear();
-            return View(loginViewModelService.GetLoginViewModel());
+            var user = HttpContext.Session.GetString("UserId");
+            if(user != null && user != "")
+            {
+                Guid t = Guid.Parse(user);
+                weblog.logout(t);
+                HttpContext.Session.Clear();
+            }
+            return View(new LoginViewModel());
+
         }
         /// <summary>
@@ -40,11 +50,13 @@
             if (!string.IsNullOrEmpty(loginName) && !string.IsNullOrEmpty(password))
             {
-                var model = loginViewModelService.GetLoginViewModel();
-                HiveServiceLocatorWeb hiveServiceLocator = (HiveServiceLocatorWeb)HiveServiceLocatorWeb.Instance;
-                HeuristicLab.Clients.Common.Properties.Settings.Default.UserName = loginName;
-                HeuristicLab.Clients.Common.Properties.Settings.Default.Password = Common.CryptoService.EncryptString(password);
-                HeuristicLab.Clients.Common.Properties.Settings.Default.Save();
+                var passE = Common.CryptoService.EncryptString(password);
+                var model = new LoginViewModel(loginName, passE);
+                HiveServiceLocatorWeb hiveServiceLocator = new HiveServiceLocatorWeb();
+                Common.Properties.Settings.Default.UserName = loginName;
+                Common.Properties.Settings.Default.Password = passE;
+                Common.Properties.Settings.Default.Save();
                 hiveServiceLocator.Username = loginName;
                 hiveServiceLocator.Password = password;
+                hiveServiceLocator.UserId = model.userId;
 
                 client = hiveServiceLocator.getHiveServiceClient();
@@ -52,5 +64,6 @@
                     var test = client.GetJobs();//Throws messageSecurityException if login failss
                     ViewBag.Title = "Login succesful";
-                    
+                    weblog.newLogin(model, hiveServiceLocator);
+                    HttpContext.Session.SetString("UserId", model.userId.ToString());
                     return RedirectToAction("Index","Job");
                 }
@@ -58,4 +71,5 @@
                 {
                     ViewBag.Title = "Login";
+                    model = new LoginViewModel();
                     model.errorMessage = "Wrong login, try again";
                     return View("Index", model);
@@ -66,5 +80,5 @@
             {
                 ViewBag.Title = "Login";
-                var model = loginViewModelService.GetLoginViewModel();
+                var model = new LoginViewModel();
                 model.errorMessage = "You should fill in both fields";
                 return View("Index", model);
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/JobController.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/JobController.cs	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/JobController.cs	(revision 13739)
@@ -23,17 +23,45 @@
     public class JobController : Controller
     {
-        private HiveServiceClient client;
+        private WebLoginService weblog;
+
+        private HiveServiceLocatorWeb serviceLocator;
+        private HiveServiceClient serviceClient;
+        private HiveClientWeb clientWeb;
+        private Guid userId;
+
         private JobViewModel vm;
         private IHostingEnvironment _environment;
 
+
+
         public JobController(IHostingEnvironment env)
         {
-            HiveServiceLocatorWeb hiveServiceLocator = (HiveServiceLocatorWeb)HiveServiceLocatorWeb.Instance;
-            client = hiveServiceLocator.getHiveServiceClient();
+            weblog = WebLoginService.Instance;
             vm = new JobViewModel();
-
-
             _environment = env;
         }
+
+        /// <summary>
+        /// initializes the connection for the right user. Not constructor because httpcontext is needed.
+        /// </summary>
+        private void init()
+        {
+            var u = HttpContext.Session.GetString("UserId");
+            if (u == null || u == "" || Guid.Parse(u) == Guid.Empty)
+            {
+                userId = Guid.Empty;
+                serviceLocator = new HiveServiceLocatorWeb();
+                serviceClient = serviceLocator.getHiveServiceClient();
+                clientWeb = new HiveClientWeb(serviceLocator, userId);
+            }
+            else
+            {
+                userId = Guid.Parse(u);
+                serviceLocator = weblog.getServiceLocator(userId);
+                serviceClient = serviceLocator.getHiveServiceClient();
+                clientWeb = weblog.getClientWeb(userId);
+            }
+        }
+
         #region Jobs
         /// <summary>
@@ -45,7 +73,7 @@
             try
             {
-                HiveClientWeb.Instance.Refresh();
-
-                vm.userJobs = HiveClientWeb.Instance.Jobs.ToList();
+                init();
+                clientWeb.Refresh();
+                vm.userJobs = clientWeb.Jobs.ToList();
             }
             catch (Exception e)
@@ -53,9 +81,9 @@
                 if (e is MessageSecurityException || e is InvalidOperationException)
                 {
-                    HiveServiceLocatorWeb.SetLoginErrorMessage();
                     return RedirectToAction("Index", "Home");
                 }
                 throw;
             }
+            ViewBag.SessionId = HttpContext.Session.GetString("UserId");
             ViewBag.Title = "Jobs";
             return View(vm);
@@ -68,26 +96,27 @@
         public IActionResult Selected(Guid id)
         {
-            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
-            {
-                HiveClientWeb.Instance.Refresh();
-                
-                vm.userJobs = HiveClientWeb.Instance.Jobs.ToList();
-                foreach(var j in vm.userJobs)
-                {
-                    if(j.Id == id)
+            init();
+            if (serviceLocator.CheckLogin())
+            {
+                clientWeb.Refresh();
+
+                vm.userJobs = clientWeb.Jobs.ToList();
+                foreach (var j in vm.userJobs)
+                {
+                    if (j.Id == id)
                     {
                         vm.selectedJob = j;
                     }
                 }
-                vm.selectedJob.RefreshAutomatically = true;
-                 HiveClientWeb.LoadJob(vm.selectedJob);
-                FileOpeningService.Instance.NewModel();
-                FileOpeningService.Instance.Job = vm.selectedJob;
+                //vm.selectedJob.RefreshAutomatically = true;
+                clientWeb.LoadJob(vm.selectedJob);
+                weblog.getFileOpener(userId).NewModel();
+                weblog.getFileOpener(userId).Job = vm.selectedJob;
                 ViewBag.Title = vm.selectedJob.Job.Name + " - Jobs";
+                ViewBag.SessionId = HttpContext.Session.GetString("UserId");
                 return View("Index", vm);
             }
             else
             {
-                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
@@ -100,12 +129,13 @@
         public IActionResult Delete(Guid id)
         {
-            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
-            {
-
-                vm.message = client.GetJob(id).Name + " deleted";
-                client.DeleteJob(id);
-                HiveClientWeb.Instance.Refresh();
-
-                vm.userJobs = HiveClientWeb.Instance.Jobs.ToList();
+            init();
+            if (serviceLocator.CheckLogin())
+            {
+
+                vm.message = serviceClient.GetJob(id).Name + " deleted";
+                serviceClient.DeleteJob(id);
+                clientWeb.Refresh();
+
+                vm.userJobs = clientWeb.Jobs.ToList();
                 ViewBag.Title = "Jobs";
                 return View("Index", vm);
@@ -113,5 +143,4 @@
             else
             {
-                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
@@ -126,9 +155,10 @@
         public IActionResult Uploads()
         {
-            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
+            init();
+            if (serviceLocator.CheckLogin())
             {
                 UploadedJobViewModel upper = new UploadedJobViewModel();
                 fillUploadsPaths(upper, -1);
-                ViewBag.Name = client.ClientCredentials.UserName.UserName;
+                ViewBag.Name = serviceClient.ClientCredentials.UserName.UserName;
                 ViewBag.Title = "Uploaded files";
                 return View("Uploads", upper);
@@ -136,5 +166,4 @@
             else
             {
-                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
@@ -147,5 +176,6 @@
         public IActionResult UploadDir(int index)
         {
-            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
+            init();
+            if (serviceLocator.CheckLogin())
             {
                 UploadedJobViewModel upper = new UploadedJobViewModel();
@@ -157,5 +187,4 @@
             else
             {
-                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
@@ -167,8 +196,7 @@
         /// <param name="index">Index selected directory</param>
         private void fillUploadsPaths(UploadedJobViewModel vm, int index)
-            
         {
             var tempdex = index; //Fix when maps gets deleted
-            var start = Path.Combine(_environment.WebRootPath, "uploads", client.ClientCredentials.UserName.UserName);
+            var start = Path.Combine(_environment.WebRootPath, "uploads", serviceClient.ClientCredentials.UserName.UserName);
             var dirs = Directory.GetDirectories(start);
             foreach (string dir in dirs)
@@ -205,5 +233,6 @@
         public IActionResult DeleteFile(int index, int filedex)
         {
-            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
+            init();
+            if (serviceLocator.CheckLogin())
             {
                 UploadedJobViewModel upper = new UploadedJobViewModel();
@@ -221,5 +250,4 @@
             else
             {
-                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
@@ -233,10 +261,11 @@
         public IActionResult OpenFile(int index, int filedex)
         {
-            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
+            init();
+            if (serviceLocator.CheckLogin())
             {
                 UploadedJobViewModel upper = new UploadedJobViewModel();
                 fillUploadsPaths(upper, index);
 
-                FileOpeningService serve = FileOpeningService.Instance;
+                var serve = weblog.getFileOpener(userId);
                 serve.NewModel();
                 serve.env = _environment;
@@ -260,10 +289,9 @@
                 ViewBag.JobsCount = serve.Job.Job.JobCount;
                 ViewBag.Title = serve.vm.SelectedTask.ItemTask.Name + " - Open file";
-
+                ViewBag.SessionId = HttpContext.Session.GetString("UserId");
                 return View("OpenFile", serve.vm);
             }
             else
             {
-                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
@@ -275,18 +303,18 @@
         public IActionResult AddToHive()
         {
-            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
-            {
-                    var job = FileOpeningService.Instance.AddCurrentModelToHive();
-                    while (job.Progress.ProgressValue != 1)
-                    { }
-
-                    Thread.Sleep(1000);
-                    job.Progress.Status = "Upload finished";
-                    Thread.Sleep(2000);
-                    return RedirectToAction("Index", "Job");
-            }
-            else
-            {
-                HiveServiceLocatorWeb.SetLoginErrorMessage();
+            init();
+            if (serviceLocator.CheckLogin())
+            {
+                var job = weblog.getFileOpener(userId).AddCurrentModelToHive();
+                while (job.Progress.ProgressValue != 1)
+                { }
+
+                Thread.Sleep(1000);
+                job.Progress.Status = "Upload finished";
+                Thread.Sleep(2000);
+                return RedirectToAction("Index", "Job");
+            }
+            else
+            {
                 return RedirectToAction("Index", "Home");
             }
@@ -334,7 +362,7 @@
         public async Task<IActionResult> Uploader(ICollection<IFormFile> files, string directory)
         {
-
+            init();
             UploadedJobViewModel upper = new UploadedJobViewModel();
-            var uploads = Path.Combine(_environment.WebRootPath, "uploads", client.ClientCredentials.UserName.UserName,
+            var uploads = Path.Combine(_environment.WebRootPath, "uploads", serviceClient.ClientCredentials.UserName.UserName,
                 directory);
             Directory.CreateDirectory(uploads);
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/ResourceController.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/ResourceController.cs	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/ResourceController.cs	(revision 13739)
@@ -1,4 +1,5 @@
 ﻿using HeuristicLab.Clients.Hive.WebJobManager.Services;
 using Microsoft.AspNet.Hosting;
+using Microsoft.AspNet.Http;
 using Microsoft.AspNet.Mvc;
 using System;
@@ -12,11 +13,30 @@
     public class ResourceController : Controller
     {
-        private HiveServiceClient client;
+        private WebLoginService weblog;
+        private HiveServiceLocatorWeb serviceLocator;
+        private HiveServiceClient serviceClient;
+        private HiveClientWeb clientWeb;
+        private Guid userId;
+
         private IHostingEnvironment _environment;
 
         public ResourceController(IHostingEnvironment env)
         {
-            HiveServiceLocatorWeb hiveServiceLocator = (HiveServiceLocatorWeb)HiveServiceLocatorWeb.Instance;
-            client = hiveServiceLocator.getHiveServiceClient();
+            weblog = WebLoginService.Instance;
+            var u = HttpContext.Session.GetString("UserId");
+            if (u == null || u == "" || Guid.Parse(u) == Guid.Empty)
+            {
+                userId = Guid.Empty;
+                serviceLocator = new HiveServiceLocatorWeb();
+                serviceClient = serviceLocator.getHiveServiceClient();
+                clientWeb = new HiveClientWeb(serviceLocator, userId);
+            }
+            else {
+                userId = Guid.Parse(u);
+
+                serviceLocator = weblog.getServiceLocator(userId);
+                serviceClient = serviceLocator.getHiveServiceClient();
+                clientWeb = weblog.getClientWeb(userId);
+            }
 
             _environment = env;
@@ -24,5 +44,5 @@
         public IActionResult Index()
         {
-            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
+            if (serviceLocator.CheckLogin())
             {
 
@@ -32,5 +52,4 @@
             else
             {
-                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/UserController.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/UserController.cs	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Controllers/UserController.cs	(revision 13739)
@@ -1,4 +1,5 @@
 ﻿using HeuristicLab.Clients.Hive.WebJobManager.Services;
 using Microsoft.AspNet.Hosting;
+using Microsoft.AspNet.Http;
 using Microsoft.AspNet.Mvc;
 using System;
@@ -12,11 +13,30 @@
     public class UserController: Controller
     {
-        private HiveServiceClient client;
+        private WebLoginService weblog;
+        private HiveServiceLocatorWeb serviceLocator;
+        private HiveServiceClient serviceClient;
+        private HiveClientWeb clientWeb;
+        private Guid userId;
+
         private IHostingEnvironment _environment;
 
         public UserController(IHostingEnvironment env)
         {
-            HiveServiceLocatorWeb hiveServiceLocator = (HiveServiceLocatorWeb)HiveServiceLocatorWeb.Instance;
-            client = hiveServiceLocator.getHiveServiceClient();
+            weblog = WebLoginService.Instance;
+            var u = HttpContext.Session.GetString("UserId");
+            if (u == null || u == "" || Guid.Parse(u) == Guid.Empty)
+            {
+                userId = Guid.Empty;
+                serviceLocator = new HiveServiceLocatorWeb();
+                serviceClient = serviceLocator.getHiveServiceClient();
+                clientWeb = new HiveClientWeb(serviceLocator, userId);
+            }
+            else {
+                userId = Guid.Parse(u);
+
+                serviceLocator = weblog.getServiceLocator(userId);
+                serviceClient = serviceLocator.getHiveServiceClient();
+                clientWeb = weblog.getClientWeb(userId);
+            }
 
             _environment = env;
@@ -24,5 +44,5 @@
         public IActionResult Index()
         {
-            if (((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).CheckLogin())
+            if (serviceLocator.CheckLogin())
             {
                 
@@ -32,5 +52,4 @@
             else
             {
-                HiveServiceLocatorWeb.SetLoginErrorMessage();
                 return RedirectToAction("Index", "Home");
             }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/JobUpdaterHub.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/JobUpdaterHub.cs	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/JobUpdaterHub.cs	(revision 13739)
@@ -1,8 +1,10 @@
 ﻿using HeuristicLab.Clients.Hive.WebJobManager.Services;
 using HeuristicLab.Common;
+using Microsoft.AspNet.Http;
 using Microsoft.AspNet.SignalR;
 using Newtonsoft.Json;
 using System;
 using System.Collections.Generic;
+using System.Threading.Tasks;
 
 namespace HeuristicLab.Clients.Hive.WebJobManager
@@ -15,5 +17,22 @@
         
         private RefreshableJob Job;//Current job (only used as reference, instance gets lost)
-     
+
+        private WebLoginService weblog;
+        private FileOpeningService fileopener;
+        private Guid userId;
+
+        private void loader()
+        {
+            weblog = WebLoginService.Instance;
+            string uid = Context.QueryString["userid"];
+            if (uid == null || uid == "" || Guid.Parse(uid) == Guid.Empty)
+            {
+                userId = Guid.Empty;
+            }
+            else {
+                userId = Guid.Parse(uid);
+                fileopener = weblog.getFileOpener(userId);
+            }
+        }
         /// <summary>
         /// Initial connection call from client
@@ -21,7 +40,8 @@
         public void initConnection()
         {
-            FileOpeningService.Instance.previousids = new List<Guid>();
-            FileOpeningService.Instance.previousLogs = new List<int>();
-            Job = FileOpeningService.Instance.Job;
+            loader();
+            fileopener.previousids = new List<Guid>();
+            fileopener.previousLogs = new List<int>();
+            Job = fileopener.Job;
             updateAll();//start initial update
 
@@ -32,6 +52,7 @@
         public void updateAll()
         {
-            FileOpeningService.Instance.refreshJob();//refresh all data from job
-            Job = FileOpeningService.Instance.Job;
+            loader();
+            fileopener.refreshJob();//refresh all data from job
+            Job = fileopener.Job;
             updateJob();
             foreach (var t in Job.HiveTasks)
@@ -45,5 +66,5 @@
 
         }
-        public void updateJob()
+        private void updateJob()
         {
             Clients.Caller.processJobData(Job.Job.CalculatingCount, Job.Job.FinishedCount);
@@ -59,19 +80,19 @@
                 int index;
                 bool test = false;
-                if (FileOpeningService.Instance.previousids.Contains(task.Task.Id))
+                if (fileopener.previousids.Contains(task.Task.Id))
                 {
-                    index = FileOpeningService.Instance.previousids.IndexOf(task.Task.Id);
+                    index = fileopener.previousids.IndexOf(task.Task.Id);
                 }
                 else
                 {//initial add to previous list, used to check if updates happened
-                    FileOpeningService.Instance.previousids.Add(task.Task.Id);
-                    index = FileOpeningService.Instance.previousids.IndexOf(task.Task.Id);
-                    FileOpeningService.Instance.previousLogs.Add(task.Task.StateLog.Count);
+                    fileopener.previousids.Add(task.Task.Id);
+                    index = fileopener.previousids.IndexOf(task.Task.Id);
+                    fileopener.previousLogs.Add(task.Task.StateLog.Count);
                     test = true;//initial added task, data must be sent
                 }
-                var previous = FileOpeningService.Instance.previousLogs[index];
+                var previous = fileopener.previousLogs[index];
                 if (test || previous < task.Task.StateLog.Count)
                 {//Checks if change happened so data is not sent unnecessary 
-                    FileOpeningService.Instance.previousLogs[index] = task.Task.StateLog.Count;
+                    fileopener.previousLogs[index] = task.Task.StateLog.Count;
                     JsonSerializerSettings settings = new JsonSerializerSettings();
                     settings.ContractResolver = new JsonTaskResolver();
@@ -94,5 +115,6 @@
         public void restartTask(Guid id)
         {
-            ((HiveServiceLocatorWeb)(HiveServiceLocatorWeb.Instance)).getHiveServiceClient().RestartTask(id);
+            loader();
+            weblog.getServiceLocator(userId).getHiveServiceClient().RestartTask(id);
         }
     }
Index: branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/ProgressHub.cs
===================================================================
--- branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/ProgressHub.cs	(revision 13735)
+++ branches/WebJobManager/HeuristicLab.Clients.Hive.WebJobManager/Hubs/ProgressHub.cs	(revision 13739)
@@ -15,5 +15,21 @@
     public class ProgressHub : Hub
     {
-        private RefreshableJob Job;
+        private WebLoginService weblog;
+        private Guid userId;
+        private FileOpeningService fileopener;
+        private void loader()
+        {
+            weblog = WebLoginService.Instance;
+            string uid = Context.QueryString["userid"];
+            if (uid == null || uid == "" || Guid.Parse(uid) == Guid.Empty)
+            {
+                userId = Guid.Empty;
+            }
+            else {
+                userId = Guid.Parse(uid);
+                fileopener = weblog.getFileOpener(userId);
+            }
+        }
+
         /// <summary>
         /// First message from client
@@ -22,8 +38,7 @@
         public void HandleMessage(string receivedString)
         {
-
+            loader();
             Clients.Caller.processMessage("Connection Established");
-            Job = FileOpeningService.Instance.Job;
-            Job.Progress.StatusChanged += runHub;
+            fileopener.Job.Progress.StatusChanged += runHub;
         }
         /// <summary>
@@ -33,9 +48,10 @@
         public void ChangeNameResource(string name, string resource)
         {
+            loader();
             if (name != null)
-                FileOpeningService.Instance.Job.Job.Name = name;
+                fileopener.Job.Job.Name = name;
             if(resource != null && resource != "")
             {
-                FileOpeningService.Instance.Job.Job.ResourceNames += "/" + resource;
+                fileopener.Job.Job.ResourceNames += "/" + resource;
             }
         }
@@ -49,6 +65,6 @@
         public void ToggleChild(int[][] arr)
         {
-            Job = FileOpeningService.Instance.Job;
-            HiveTask current = Job.HiveTasks.ToList()[0];
+            loader();
+            HiveTask current = fileopener.Job.HiveTasks.ToList()[0];
             if (arr.Length == 0)
             {//check if upper job
@@ -92,6 +108,6 @@
         public void ChangePriority(int[][] arr, int prior)
         {
-            Job = FileOpeningService.Instance.Job;
-            HiveTask current = Job.HiveTasks.ToList()[0];
+            loader();
+            HiveTask current = fileopener.Job.HiveTasks.ToList()[0];
             if (arr.Length == 0)
             {//check if upper job
@@ -132,7 +148,8 @@
         public void runHub(object sender, EventArgs e)
         {
+            loader();
             int value = 0;
 
-            switch (Job.Progress.Status)
+            switch (fileopener.Job.Progress.Status)
             {
                 case "Connecting to server...":
@@ -152,10 +169,10 @@
                     break;
                 default://Tasks are uploading individually
-                    value = (int)(50 + (40 * Job.Progress.ProgressValue));
+                    value = (int)(50 + (40 * fileopener.Job.Progress.ProgressValue));
                     break;
 
             }
             //send info to client
-            Clients.Caller.processMessage(Job.Progress.Status, value);
+            Clients.Caller.processMessage(fileopener.Job.Progress.Status, value);
 
         }
